#include "TeleMod.h"

#define WAIT_FOR_SLOTS_AVAILABLE_MS    5

void
notifySent(struct bt_conn *conn, void *user_data) {
//  printk("Notification out\n");
  bleNotificationsAvailable= bleNotificationsAvailable + 1;
}

//
// This thread sits, waiting for a message to appear in the queue.
// The message contains an instance of "CharQueueData".
// CharQueueData contains an address of the data to send and the packetType
//
void
threadBleSend(int unused1, int unused2, int unused3) {
  uint32_t err;
  bleSendQueueItem *charPtr;

  static struct bt_gatt_notify_params notifyParams;

  for(;;) {
    // Block until a FIFO item arrives...
    // Only try to read if we can send (slots available)
    if(bleNotificationsAvailable <= 0) {
      // There are no available slots for Notification sending
      // Put in a small delay so task doesn't hog CPU, then check again
//printk("No more buffers available!\n");
      k_sleep(K_MSEC(WAIT_FOR_SLOTS_AVAILABLE_MS));
    } else {
      // Attempt to read the fifo, blocking until one appears
      charPtr= k_fifo_get(&notifyQueue, K_FOREVER);
//printk("Packet received via FIFO: MTU size: %d\n",bt_gatt_get_mtu(charPtr->conn));
      // QueueItem has arrived from some other thread
      // Move data into "notify" format
      notifyParams.uuid      = NULL;
      notifyParams.attr      = charPtr->characteristic;
      notifyParams.data      = charPtr->data;
      notifyParams.len       = charPtr->len;
      notifyParams.func      = notifySent;
      notifyParams.user_data = NULL;
//printk("Subscription: %d\n",bt_gatt_is_subscribed(charPtr->conn,charPtr->characteristic,BT_GATT_CHRC_NOTIFY));
      err= bt_gatt_notify_cb(charPtr->conn,&notifyParams);
      //err= bt_gatt_notify(charPtr->conn,charPtr->characteristic,charPtr->data,charPtr->len);
//printk("    Notification sent: %d\n",err);
      // We've used a notification buffer
      bleNotificationsAvailable--;
    }
  }
}
