#ifndef SGTL5000_H
#define SGTL5000_H
//
//
#define SGTL5000_I2C_ADDRESS  			  0x0A

//
// Register Definitions
//
#define SGTL5000_CHIP_ID			0x0000
#define SGTL5000_CHIP_DIG_POWER			0x0002
#define		ENABLE_I2S_IN_POWER		0x0001
#define		ENABLE_I2S_OUT_POWER		0x0002
#define		ENABLE_DAP_POWER		0x0010
#define		ENABLE_DAC_POWER		0x0020
#define		ENABLE_ADC_POWER		0x0040
#define SGTL5000_CHIP_CLK_CTRL			0x0004
#define		FREQ_MASK			0x0003
#define		FREQ_FSx256			0x0000
#define		FREQ_FSx384			0x0001
#define		FREQ_FSx512			0x0002
#define		FREQ_PLL			0x0003
#define		SAMP_MASK			0x000C
#define		SAMP_32KHZ			0x0000
#define		SAMP_44_1KHZ			0x0004
#define		SAMP_48KHZ			0x0008
#define		SAMP_96KHZ			0x000C
#define		RATE_MODE_MASK			0x0030
#define		RATE_MODE_SYS_FS		0x0000
#define		RATE_MODE_0_50			0x0010
#define		RATE_MODE_0_25			0x0020
#define		RATE_MODE_0_167			0x0030
#define SGTL5000_CHIP_I2S_CTRL			0x0006
#define		LRPOL_MASK			0x0001
#define		LRPOL_L0R1			0x0000
#define		LRPOL_L1R0			0x0001
#define		LRALIGN_MASK			0x0002
#define		LRALIGN_DELAY			0x0000
#define		LRALIGN_LEFT			0x0002
#define		I2S_MODE_MASK			0x000C
#define		I2S_MODE_LEFT_JUSTIFIED		0x0000
#define		I2S_MODE_RIGHT_JUSTIFIED	0x0004
#define		I2S_MODE_PCM			0x0008
#define		I2S_SIZE_MASK			0x0030
#define		I2S_SIZE_32			0x0000
#define		I2S_SIZE_24			0x0010
#define		I2S_SIZE_20			0x0020
#define		I2S_SIZE_16			0x0030
#define		I2S_SCLK_MASK			0x0040
#define		I2S_SCLK_RISING			0x0000
#define		I2S_SCLK_FALLING		0x0040
#define		I2S_MS_MASK			0x0080
#define		I2S_MASTER			0x0080
#define		I2S_SLAVE			0x0000
#define		I2S_SCLK_FREQ_MASK		0x0100
#define		I2S_SCLK_FREQ_FSx32		0x0100
#define		I2S_SCLK_FREQ_FSx64		0x0000
#define SGTL5000_CHIP_SSS_CTRL			0x000A
#define		I2S_OUTPUT_SELECT_MASK		0x0003
#define		I2S_OUTPUT_ADC			0x0000
#define		I2S_OUTPUT_I2S_IN		0x0001
#define		I2S_OUTPUT_DAP			0x0003
#define		I2S_DAC_INPUT_SELECT_MASK	0x0030
#define		I2S_DAC_INPUT_ADC		0x0000
#define		I2S_DAC_INPUT_I2S_IN		0x0010
#define		I2S_DAC_INPUT_DAP		0x0030
#define		I2S_DAP_INPUT_SELECT_MASK	0x00C0
#define		I2S_DAP_INPUT_ADC		0x0000
#define		I2S_DAP_INPUT_I2S_IN		0x0040
#define		I2S_DAP_MIXER_SELECT_MASK	0x0300
#define		I2S_DAP_MIXER_ADC		0x0000
#define		I2S_DAP_MIXER_I2S_IN		0x0100
#define		I2S_LRSWAP_SELECT_MASK		0x0400
#define		I2S_LRSWAP_NORMAL		0x0000
#define		I2S_LRSWAP_SWAPPED		0x0400
#define		DAC_LRSWAP_SELECT_MASK		0x1000
#define		DAC_LRSWAP_NORMAL		0x0000
#define		DAC_LRSWAP_SWAPPED		0x1000
#define		DAP_LRSWAP_SELECT_MASK		0x2000
#define		DAP_LRSWAP_NORMAL		0x0000
#define		DAP_LRSWAP_SWAPPED		0x2000
#define		DAP_MIX_LRSWAP_SELECT_MASK	0x4000
#define		DAP_MIX_LRSWAP_NORMAL		0x0000
#define		DAP_MIX_LRSWAP_SWAPPED		0x4000
#define SGTL5000_CHIP_ADCDAC_CTRL		0x000E
#define		ADC_HPF_BYPASS_SELECT_MASK	0x0001
#define		ADC_HPF_BYPASS_NORMAL		0x0000
#define		ADC_HPF_BYPASS_ENABLE		0x0001
#define		ADC_HPF_FREEZE_SELECT_MASK	0x0002
#define		ADC_HPF_FREEZE_NORMAL		0x0000
#define		ADC_HPF_FREEZE_ENABLE		0x0002
#define		ADC_DAC_MUTE_LEFT_SELECT_MASK	0x0004
#define		ADC_DAC_MUTE_LEFT_UNMUTED	0x0000
#define		ADC_DAC_MUTE_LEFT_MUTED		0x0004
#define		ADC_DAC_MUTE_RIGHT_SELECT_MASK	0x0008
#define		ADC_DAC_MUTE_RIGHT_UNMUTED	0x0000
#define		ADC_DAC_MUTE_RIGHT_MUTED	0x0008
#define		VOL_EXPO_RAMP_SELECT_MASK	0x0100
#define		VOL_EXPO_RAMP_LINEAR		0x0000
#define		VOL_EXPO_RAMP_EXPO		0x0100
#define		VOL_RAMP_EN_SELECT_MASK		0x0200
#define		VOL_RAMP_EN_DISABLED		0x0000
#define		VOL_RAMP_EN_ENABLED		0x0200
#define		VOL_BUSY_DAC_LEFT_SELECT_MASK	0x1000
#define		VOL_BUSY_DAC_LEFT_READY		0x0000
#define		VOL_BUSY_DAC_LEFT_BUSY		0x1000
#define		VOL_BUSY_DAC_RIGHT_SELECT_MASK	0x2000
#define		VOL_BUSY_DAC_RIGHT_READY	0x0000
#define		VOL_BUSY_DAC_RIGHT_BUSY		0x2000
#define SGTL5000_CHIP_DAC_VOL			0x0010
#define		DAC_VOL_LEFT_MASK		0x00ff
#define		DAC_VOL_RIGHT_MASK		0xff00
#define SGTL5000_CHIP_PAD_STRENGTH		0x0014
#define		I2C_CTRL_CLK_STRENGTH_MASK	0x0003
#define		I2C_CTRL_CLK_DISABLE		0x0000
#define		I2C_CTRL_CLK_LOW_STRENGTH	0x0001
#define		I2C_CTRL_CLK_MID_STRENGTH	0x0002
#define		I2C_CTRL_CLK_HI_STRENGTH	0x0003
#define		I2C_CTRL_DATA_STRENGTH_MASK	0x000C
#define		I2C_CTRL_DATA_DISABLE		0x0000
#define		I2C_CTRL_DATA_LOW_STRENGTH	0x0004
#define		I2C_CTRL_DATA_MID_STRENGTH	0x0008
#define		I2C_CTRL_DATA_HI_STRENGTH	0x000C
#define		I2S_DOUT_STRENGTH_MASK		0x0030
#define		I2S_DOUT_DISABLE		0x0000
#define		I2S_DOUT_LOW_STRENGTH		0x0010
#define		I2S_DOUT_MID_STRENGTH		0x0020
#define		I2S_DOUT_HI_STRENGTH		0x0030
#define		I2S_SCLK_STRENGTH_MASK		0x00C0
#define		I2S_SCLK_DISABLE		0x0000
#define		I2S_SCLK_LOW_STRENGTH		0x0040
#define		I2S_SCLK_MID_STRENGTH		0x0080
#define		I2S_SCLK_HI_STRENGTH		0x00C0
#define		I2S_LRCLK_STRENGTH_MASK		0x0300
#define		I2S_LRCLK_DISABLE		0x0000
#define		I2S_LRCLK_LOW_STRENGTH		0x0100
#define		I2S_LRCLK_MID_STRENGTH		0x0200
#define		I2S_LRCLK_HI_STRENGTH		0x0300
#define SGTL5000_CHIP_ANA_ADC_CTRL		0x0020
#define		ADC_VOL_LEFT_MASK		0x000F
#define		ADC_VOL_RIGHT_MASK		0x00F0
#define		ADC_VOL_M6DB_SELECT_MASK	0x0100
#define		ADC_VOL_M6DB_NORMAL		0x0000
#define		ADC_VOL_M6DB_ENABLED		0x0100
#define SGTL5000_CHIP_ANA_HP_CTRL		0x0022
#define		HP_VOL_LEFT_MASK		0x003F
#define		HP_VOL_RIGHT_MASK		0x3F00
#define SGTL5000_CHIP_ANA_CTRL			0x0024
#define		MUTE_ADC_SELECT_MASK		0x0001
#define		MUTE_ADC_UNMUTED		0x0000
#define		MUTE_ADC_MUTED			0x0001
#define		EN_ZCD_ADC_SELECT_MASK		0x0002
#define		EN_ZCD_ADC_DISABLED		0x0000
#define		EN_ZCD_ADC_ENABLED		0x0002
#define		SELECT_ADC_INPUT_SELECT_MASK	0x0004
#define		SELECT_ADC_INPUT_MICROPHONE	0x0000
#define		SELECT_ADC_INPUT_LINEIN		0x0004
#define		MUTE_HP_SELECT_MASK		0x0010
#define		MUTE_HP_UNMUTED			0x0000
#define		MUTE_HP_MUTED			0x0010
#define		EN_ZCD_HP_SELECT_MASK		0x0020
#define		EN_ZCD_HP_DISABLED		0x0000
#define		EN_ZCD_HP_ENABLED		0x0020
#define		SELECT_HP_INPUT_SELECT_MASK	0x0040
#define		SELECT_HP_INPUT_DAC		0x0000
#define		SELECT_HP_INPUT_LINEIN		0x0040
#define		MUTE_LINEOUT_SELECT_MASK	0x0100
#define		MUTE_LINEOUT_UNMUTED		0x0000
#define		MUTE_LINEOUT_MUTED		0x0100
#define SGTL5000_CHIP_LINREG_CTRL		0x0026
#define		D_PROGRAMMING_SELECT_MASK	0x000F
#define		VDDD_OUT_1_60V			0x0000
#define		VDDD_OUT_1_55V			0x0001
#define		VDDD_OUT_1_50V			0x0002
#define		VDDD_OUT_1_45V			0x0003
#define		VDDD_OUT_1_40V			0x0004
#define		VDDD_OUT_1_35V			0x0005
#define		VDDD_OUT_1_30V			0x0006
#define		VDDD_OUT_1_25V			0x0007
#define		VDDD_OUT_1_20V			0x0008
#define		VDDD_OUT_1_15V			0x0009
#define		VDDD_OUT_1_10V			0x000A
#define		VDDD_OUT_1_05V			0x000B
#define		VDDD_OUT_1_00V			0x000C
#define		VDDD_OUT_0_95V			0x000D
#define		VDDD_OUT_0_90V			0x000E
#define		VDDD_OUT_0_85V			0x000F
#define		VDDC_ASSN_OVRD_SELECT_MASK	0x0020
#define		VDDC_ASSN_AUTO			0x0000
#define		VDDC_ASSN_MANUAL		0x0020
#define		VDDC_MAN_ASSN_SELECT_MASK	0x0040
#define		VDDC_MAN_VDDA			0x0000
#define		VDDC_MAN_VDDIO			0x0040
#define SGTL5000_CHIP_REF_CTRL			0x0028
#define		SMALL_POP_SELECT_MASK		0x0001
#define		SMALL_POP_NORMAL		0x0000
#define		SMALL_POP_SLOW			0x0001
#define		BIAS_CTRL_SELECT_MASK		0x000E
#define         BIAS_NOMINAL                    0x0000
#define         BIAS_P12_5_PERCENT              0x0002
#define         BIAS_M12_5_PERCENT              0x0008
#define         BIAS_M25_0_PERCENT              0x000A
#define         BIAS_M37_5_PERCENT              0x000C
#define         BIAS_M50_0_PERCENT              0x000E
#define		VAG_VAL_SELECT_MASK		0x01F0
#define		VAG_0_800V                      0x0000
#define         VAG_0_825V                      0x0010
#define         VAG_0_850V                      0x0020
#define         VAG_0_875V                      0x0030
#define         VAG_0_900V                      0x0040
#define         VAG_0_925V                      0x0050
#define         VAG_0_950V                      0x0060
#define         VAG_0_975V                      0x0070
#define         VAG_1_000V                      0x0080
#define         VAG_1_025V                      0x0090
#define         VAG_1_050V                      0x00A0
#define         VAG_1_075V                      0x00B0
#define         VAG_1_100V                      0x00C0
#define         VAG_1_125V                      0x00D0
#define         VAG_1_150V                      0x00E0
#define         VAG_1_175V                      0x00F0
#define         VAG_1_200V                      0x0100
#define         VAG_1_225V                      0x0110
#define         VAG_1_250V                      0x0120
#define         VAG_1_275V                      0x0130
#define         VAG_1_300V                      0x0140
#define         VAG_1_325V                      0x0150
#define         VAG_1_350V                      0x0160
#define         VAG_1_375V                      0x0170
#define         VAG_1_400V                      0x0180
#define         VAG_1_425V                      0x0190
#define         VAG_1_450V                      0x01A0
#define         VAG_1_475V                      0x01B0
#define         VAG_1_500V                      0x01C0
#define         VAG_1_525V                      0x01D0
#define         VAG_1_550V                      0x01E0
#define         VAG_1_575V                      0x01F0
#define SGTL5000_CHIP_MIC_CTRL			0x002A
#define		MIC_GAIN_SELECT_MASK		0x0003
#define		MIC_GAIN_0DB			0x0000
#define		MIC_GAIN_20dB			0x0001
#define		MIC_GAIN_30dB			0x0002
#define		MIC_GAIN_40dB			0x0003
#define		MIC_BIAS_VOLTAGE_SELECT_MASK	0x0070
#define		MIC_BIAS_1_25V			0x0000
#define		MIC_BIAS_1_50V			0x0010
#define		MIC_BIAS_1_75V			0x0020
#define		MIC_BIAS_2_00V			0x0030
#define		MIC_BIAS_2_25V			0x0040
#define		MIC_BIAS_2_50V			0x0050
#define		MIC_BIAS_2_75V			0x0060
#define		MIC_BIAS_3_00V			0x0070
#define		MIC_BIAS_RESISTOR_SELECT_MASK	0x0300
#define		MIC_BIAS_RESISTOR_OFF		0x0000
#define		MIC_BIAS_RESISTOR_2KOhm		0x0100
#define		MIC_BIAS_RESISTOR_4KOhm		0x0200
#define		MIC_BIAS_RESISTOR_8KOhm		0x0300
#define SGTL5000_CHIP_LINE_OUT_CTRL		0x002C
#define		LINE_OUT_VAG_SELECT_MASK	0x003F
#define		LINE_OUT_VAG_0_800V             0x0000
#define         LINE_OUT_VAG_0_825V             0x0010
#define         LINE_OUT_VAG_0_850V             0x0020
#define         LINE_OUT_VAG_0_875V             0x0030
#define         LINE_OUT_VAG_0_900V             0x0040
#define         LINE_OUT_VAG_0_925V             0x0050
#define         LINE_OUT_VAG_0_950V             0x0060
#define         LINE_OUT_VAG_0_975V             0x0070
#define         LINE_OUT_VAG_1_000V             0x0080
#define         LINE_OUT_VAG_1_025V             0x0090
#define         LINE_OUT_VAG_1_050V             0x00A0
#define         LINE_OUT_VAG_1_075V             0x00B0
#define         LINE_OUT_VAG_1_100V             0x00C0
#define         LINE_OUT_VAG_1_125V             0x00D0
#define         LINE_OUT_VAG_1_150V             0x00E0
#define         LINE_OUT_VAG_1_175V             0x00F0
#define         LINE_OUT_VAG_1_200V             0x0100
#define         LINE_OUT_VAG_1_225V             0x0110
#define         LINE_OUT_VAG_1_250V             0x0120
#define         LINE_OUT_VAG_1_275V             0x0130
#define         LINE_OUT_VAG_1_300V             0x0140
#define         LINE_OUT_VAG_1_325V             0x0150
#define         LINE_OUT_VAG_1_350V             0x0160
#define         LINE_OUT_VAG_1_375V             0x0170
#define         LINE_OUT_VAG_1_400V             0x0180
#define         LINE_OUT_VAG_1_425V             0x0190
#define         LINE_OUT_VAG_1_450V             0x01A0
#define         LINE_OUT_VAG_1_475V             0x01B0
#define         LINE_OUT_VAG_1_500V             0x01C0
#define         LINE_OUT_VAG_1_525V             0x01D0
#define         LINE_OUT_VAG_1_550V             0x01E0
#define         LINE_OUT_VAG_1_575V             0x01F0
#define         LINE_OUT_VAG_1_600V             0x0200
#define         LINE_OUT_VAG_1_625V             0x0210
#define         LINE_OUT_VAG_1_650V             0x0220
#define         LINE_OUT_VAG_1_675V             0x0230
#define		LINE_OUT_CURRENT_SELECT_MASK	0x0F00
#define		LINE_OUT_CURRENT_0_18mA		0x0000
#define		LINE_OUT_CURRENT_0_27mA		0x0100
#define		LINE_OUT_CURRENT_0_36mA		0x0300
#define		LINE_OUT_CURRENT_0_45mA		0x0700
#define		LINE_OUT_CURRENT_0_54mA		0x0F00
#define SGTL5000_CHIP_LINE_OUT_VOL		0x002E
#define		LO_VOL_LEFT_SELECT_MASK		0x001F
#define		LO_VOL_RIGHT_SELECT_MASK	0x1F00
#define SGTL5000_CHIP_ANA_POWER			0x0030
#define		LINEOUT_POWER_SELECT_MASK	0x0001
#define		LINEOUT_POWER_OFF		0x0000
#define		LINEOUT_POWER_ON		0x0001
#define		ADC_POWER_SELECT_MASK		0x0002
#define		ADC_POWER_OFF			0x0000
#define		ADC_POWER_ON			0x0002
#define		CAPLESS_HP_POWER_SELECT_MASK	0x0004
#define		CAPLESS_HP_POWER_OFF		0x0000
#define		CAPLESS_HP_POWER_ON		0x0004
#define		DAC_POWER_SELECT_MASK		0x0008
#define		DAC_POWER_OFF			0x0000
#define		DAC_POWER_ON			0x0008
#define		HP_POWER_SELECT_MASK		0x0010
#define		HP_POWER_OFF			0x0000
#define		HP_POWER_ON			0x0010
#define		REFTOP_POWER_SELECT_MASK	0x0020
#define		REFTOP_POWER_OFF		0x0000
#define		REFTOP_POWER_ON			0x0020
#define		ADC_MONO_SELECT_MASK		0x0040
#define		ADC_MONO			0x0000
#define		ADC_STEREO			0x0040
#define		VAG_POWER_SELECT_MASK		0x0080
#define		VAG_POWER_OFF			0x0000
#define		VAG_POWER_ON			0x0080
#define		VCOAMP_POWER_SELECT_MASK	0x0100
#define		VCOAMP_POWER_OFF		0x0000
#define		VCOAMP_POWER_ON			0x0100
#define		LINREG_D_POWER_SELECT_MASK	0x0200
#define		LINREG_D_POWER_OFF		0x0000
#define		LINREG_D_POWER_ON		0x0200
#define		PLL_POWER_SELECT_MASK		0x0400
#define		PLL_POWER_OFF			0x0000
#define		PLL_POWER_ON			0x0400
#define		VDDC_CHRGPMP_POWER_SELECT_MASK	0x0800
#define		VDDC_CHRGPMP_POWER_OFF		0x0000
#define		VDDC_CHRGPMP_POWER_ON		0x0800
#define		STARTUP_POWER_SELECT_MASK	0x1000
#define		STARTUP_POWER_OFF		0x0000
#define		STARTUP_POWER_ON		0x1000
#define		LINREG_SIMPLE_POWER_SELECT_MASK	0x2000
#define		LINREG_SIMPLE_POWER_OFF		0x0000
#define		LINREG_SIMPLE_POWER_ON		0x2000
#define		DAC_MONO_SELECT_MASK		0x4000
#define		DAC_MONO			0x0000
#define		DAC_STEREO			0x4000
#define SGTL5000_CHIP_PLL_CTRL			0x0032
#define		FRAC_DIVISOR_MASK		0x07FF
#define		INT_DIVISOR_MASK		0xF800
#define SGTL5000_CHIP_CLK_TOP_CTRL		0x0034
#define		INPUT_FREQ_DIV2_SELECT_MASK	0x0008
#define		INPUT_FREQ_DIV2_PASS_THRU	0x0000
#define		INPUT_FREQ_DIV2_ENABLE		0x0008
#define		ENABLE_INT_OSC_SELECT_MASK	0x0800
#define		ENABLE_INT_OSC_DISABLED		0x0000
#define		ENABLE_INT_OSC_ENABLED		0x0800
#define SGTL5000_CHIP_ANA_STATUS		0x0036
#define		PLL_STATUS_SELECT_MASK		0x0010
#define		PLL_IS_NOT_LOCKED		0x0000
#define		PLL_IS_LOCKED			0x0010
#define		CSHORT_STATUS_SELECT_MASK	0x0100
#define		CSHORT_NORMAL			0x0000
#define		CSHORT_SHORTED			0x0100
#define		LRSHORT_STATUS_SELECT_MASK	0x0200
#define		LRSHORT_NORMAL			0x0000
#define		LSRHORT_SHORTED			0x0200
#define SGTL5000_CHIP_ANA_TEST1			0x0038
#define SGTL5000_CHIP_ANA_TEST2			0x003A
#define SGTL5000_CHIP_SHORT_CTRL		0x003C
#define		MODE_CM_SHORT_DETECT_MASK	0x0003
#define		MODE_CM_SHORT_DETECT_OFF	0x0000
#define		MODE_CM_SHORT_DETECT_ENABLED	0x0001
#define		MODE_CM_SHORT_DETECT_AUTO	0x0002
#define		MODE_CM_SHORT_DETECT_MANUAL	0x0003
#define		MODE_LR_SHORT_DETECT_MASK	0x000C
#define		MODE_LR_SHORT_DETECT_OFF	0x0000
#define		MODE_LR_SHORT_DETECT_ENABLED	0x0004
#define		MODE_LR_SHORT_DETECT_AUTO	0x0008
#define		MODE_LR_SHORT_DETECT_MANUAL	0x000C
#define		LVLADJC_SELECT_MASK		0x0070
#define         LVLADJC_050mA                   0x0030
#define         LVLADJC_100mA                   0x0020
#define         LVLADJC_150mA                   0x0010
#define         LVLADJC_200mA                   0x0000
#define         LVLADJC_250mA                   0x0040
#define         LVLADJC_300mA                   0x0050
#define         LVLADJC_350mA                   0x0060
#define         LVLADJC_400mA                   0x0070
#define		LVLADJL_SELECT_MASK		0x0700
#define         LVLADJL_025mA                   0x0300
#define         LVLADJL_050mA                   0x0200
#define         LVLADJL_075mA                   0x0100
#define         LVLADJL_100mA                   0x0000
#define         LVLADJL_125mA                   0x0400
#define         LVLADJL_150mA                   0x0500
#define         LVLADJL_175mA                   0x0600
#define         LVLADJL_200mA                   0x0700
#define		LVLADJR_SELECT_MASK		0x7000
#define         LVLADJR_025mA                   0x3000
#define         LVLADJR_050mA                   0x2000
#define         LVLADJR_075mA                   0x1000
#define         LVLADJR_100mA                   0x0000
#define         LVLADJR_125mA                   0x4000
#define         LVLADJR_150mA                   0x5000
#define         LVLADJR_175mA                   0x6000
#define         LVLADJR_200mA                   0x7000
#define SGTL5000_DAP_CONTROL			0x0100
#define		DAP_EN_SELECT_MASK		0x0001
#define		DAP_EN_DISABLED			0x0000
#define		DAP_EN_ENABLED			0x0001
#define		DAP_MIX_EN_SELECT_MASK		0x0010
#define		DAP_MIX_EN_DISABLED		0x0000
#define		DAP_MIX_EN_ENABLED		0x0010
#define SGTL5000_DAP_PEQ			0x0102
#define		PEQ_FILTERS_SELECT_MASK		0x0007
#define		PEQ_FILTERS_DISABLED		0x0000
#define SGTL5000_DAP_BASS_ENHANCE		0x0104
#define		DAP_BASS_ENHANCE_SELECT_MASK	0x0001
#define		DAP_BASS_ENHANCE_DISABLED	0x0000
#define		DAP_BASS_ENHANCE_ENABLED	0x0001
#define		DAP_BASS_CUTOFF_SELECT_MASK	0x0070
#define		DAP_BASS_CUTOFF_80HZ		0x0000
#define		DAP_BASS_CUTOFF_100HZ		0x0010
#define		DAP_BASS_CUTOFF_125HZ		0x0020
#define		DAP_BASS_CUTOFF_150HZ		0x0030
#define		DAP_BASS_CUTOFF_175HZ		0x0040
#define		DAP_BASS_CUTOFF_200HZ		0x0050
#define		DAP_BASS_CUTOFF_225HZ		0x0060
#define		DAP_BYPASS_HPF_SELECT_MASK	0x0100
#define		DAP_BYPASS_HPF_ENABLED		0x0000
#define		DAP_BYPASS_HPF_BYPASSED		0x0100
#define SGTL5000_DAP_BASS_ENHANCE_CTRL		0x0106
#define		DAP_BASS_LEVEL_SELECT_MASK	0x007F
#define		DAP_BASS LR_LEVEL_MASK		0x3F00
#define SGTL5000_DAP_AUDIO_EQ			0x0108
#define		DAP_AUDIO_EQ_SELECT_MASK	0x0003
#define		DAP_AUDIO_EQ_DISABLED		0x0000
#define		DAP_AUDIO_EQ_ENABLE_PEQ		0x0001
#define		DAP_AUDIO_EQ_ENABLE_TONE	0x0002
#define		DAP_AUDIO_EQ_ENABLE_5BAND	0x0003
#define SGTL5000_DAP_SGTL_SURROUND		0x010A
#define		DAP_SURROUND_SELECT_MASK	0x0003
#define		DAP_SURROUND_DISABLED		0x0000
#define		DAP_SURROUND_MONO_ENABLED	0x0002
#define		DAP_SURROUND_STEREO_ENABLED	0x0003
#define SGTL5000_DAP_FILTER_COEF_ACCESS		0x010C
#define		DAP_FILTER_COEF_INDEX_MASK	0x00FF
#define		DAP_FILTER_COEF_WR_SELECT_MASK	0x0100
#define		DAP_FILTER_COEF_WR_DISABLE	0x0000
#define		DAP_FILTER_COEF_WR_ENABLE	0x0100
#define SGTL5000_DAP_COEF_WR_B0_MSB		0x010E
#define SGTL5000_DAP_COEF_WR_B0_LSB		0x0110
#define SGTL5000_DAP_AUDIO_EQ_BASS_BAND0	0x0116
#define		DAP_EQ_BASS_BAND0_VOL_MASK	0x007F
#define SGTL5000_DAP_AUDIO_EQ_BAND1		0x0118
#define		DAP_EQ_BASS_BAND1_VOL_MASK	0x007F
#define SGTL5000_DAP_AUDIO_EQ_BAND2		0x011A
#define		DAP_EQ_BASS_BAND2_VOL_MASK	0x007F
#define SGTL5000_DAP_AUDIO_EQ_BAND3		0x011C
#define		DAP_EQ_BASS_BAND3_VOL_MASK	0x007F
#define SGTL5000_DAP_AUDIO_EQ_TREBLE_BAND4	0x011E
#define		DAP_EQ_TREBLE_BAND4_VOL_MASK	0x007F
#define SGTL5000_DAP_MAIN_CHAN			0x0120
#define SGTL5000_DAP_MIX_CHAN			0x0122
#define SGTL5000_DAP_AVC_CTRL			0x0124
#define		DAP_AVC_ENABLE_SELECT_MASK	0x0001
#define		DAP_AVC_DISABLED		0x0000
#define		DAP_AVC_ENABLED			0x0001
#define		HARD_LIMIT_ENABLE_SELECT_MASK	0x0020
#define		HARD_LIMIT_DISABLED		0x0000
#define		HARD_LIMIT_ENABLED		0x0020
#define		LBI_RESPONSE_SELECT_MASK	0x0300
#define		MAX_GAIN_SELECT_MASK		0x3000
#define SGTL5000_DAP_AVC_THRESHOLD		0x0126
#define SGTL5000_DAP_AVC_ATTACK			0x0128
#define		DAP_AVC_ATTACK_SELECT_MASK	0x0FFF
#define SGTL5000_DAP_AVC_DECAY			0x012A
#define		DAP_AVC_DECAY_SELECT_MASK	0x0FFF
#define SGTL5000_DAP_COEF_WR_B1_MSB		0x012C
#define SGTL5000_DAP_COEF_WR_B1_LSB		0x012E
#define SGTL5000_DAP_COEF_WR_B2_MSB		0x0130
#define SGTL5000_DAP_COEF_WR_B2_LSB		0x0132
#define SGTL5000_DAP_COEF_WR_A1_MSB		0x0134
#define SGTL5000_DAP_COEF_WR_A1_LSB		0x0136
#define SGTL5000_DAP_COEF_WR_A2_MSB		0x0138
#define SGTL5000_DAP_COEF_WR_A2_LSB		0x013A

// Get MostSignificantByte of uint16_t
#define MSB(a)	((a >> 8) & 0xff)
// Get LeastSignificantByte of uint16_t
#define LSB(a)  (a & 0xff)

// Convert uint16_t to address byte sequence
#define uint16ToBytes(val,buf,n) { buf[n]= (uint8_t) MSB(val); buf[n+1]= (uint8_t) LSB(val); }

// Convert 2-byte sequence to uint16_T
#define bytesToUint16(buf) (uint16_t)( ((buf[0] << 8) & 0xff00) | (buf[1] & 0xff) )


#if 0
// SGTL5000 Register read sequence
#define SGTL5000_READ(regBytes,readBuffer,byteCnt)	                  \
    NRF_TWI_MNGR_WRITE(SGTL5000_ADDRESS,regBytes,2,NRF_TWI_MNGR_NO_STOP), \
    NRF_TWI_MNGR_READ(SGTL5000_ADDRESS,readBuffer,byteCnt,0)

// SGTL5000 Register write sequence
#define SGTL5000_WRITE(regBytes,writeBuffer,byteCnt)			  \
    NRF_TWI_MNGR_WRITE(SGTL5000_ADDRESS,regBytes,2,NRF_TWI_MNGR_NO_STOP), \
    NRF_TWI_MNGR_WRITE(SGTL5000_ADDRESS,writeBuffer,byteCnt,0)

// Function prototypes
void setHPVolumeSGTL5000(nrf_twi_mngr_t *intf, uint16_t newVol);
void setDACVolumeSGTL5000(nrf_twi_mngr_t *intf, uint16_t newVol);
void setADCVolumeSGTL5000(nrf_twi_mngr_t *intf, uint16_t newVol);
void muteSGTL5000(nrf_twi_mngr_t *intf,bool on);
void initSGTL5000(nrf_twi_mngr_t *intf);
#endif


#endif